%define anolis_release 4
%define debug_package %{nil}
%global github_source_archive_name   ippcp_2021.7

Name:               intel-ipp-crypto-mb
Summary:            Intel(R) IPP Cryptography multi-buffer library
Release:            %{anolis_release}%{?dist}
Version:            1.0.6
License:            Apache-2.0
# Upstream exclusively uses x86_64-specific intrinsics
ExclusiveArch:      x86_64
URL:                https://github.com/intel/ipp-crypto
Source0:	    https://github.com/intel/ipp-crypto/archive/refs/tags/%{github_source_archive_name}.tar.gz

Patch1000:          1000-ippcp.patch

BuildRequires: 	    cmake
BuildRequires:	    gcc
BuildRequires:	    gcc-c++
BuildRequires:      nasm
BuildRequires:	    openssl3-devel
BuildRequires: 	    python3

%description
A software crypto library optimized for Intel architecture for packet
processing applications.
It contains universal and OpenSSL compatible APIs for cryptography operations.

ExclusiveArch:      x86_64

%package devel
Summary:            Intel(R) IPP Cryptography multi-buffer library (Development Files)
Requires:           %{name} = %{version}-%{release}

%description devel
A software crypto library optimized for Intel architecture for packet
processing applications.
It contains development libraries and header files.

%package static
Summary: 	Intel(R) IPP Cryptography multi-buffer library (Development Files)
Requires:	%{name} = %{version}-%{release}

%description static 
Static file for %{name}.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -n ipp-crypto-%{github_source_archive_name} -p1

%build
%global set_build_flags %{nil}
%cmake -DARCH=intel64 \
       -DCMAKE_BUILD_TYPE=Release \
       -DNONPIC_LIB:BOOL=off \
       -DMERGED_BLD:BOOL=on \
       -DOPENSSL_INCLUDE_DIR=/usr/include/openssl3/ \
       -DOPENSSL_LIBRARIES=/usr/lib64/openssl3/ \
       -DOPENSSL_ROOT_DIR=/lib64/openssl3/ \
       -DCMAKE_INSTALL_PREFIX=%{_prefix}
%cmake_build

%install
%cmake_install
mkdir -p %{buildroot}/%{_libdir}
mv %{buildroot}/usr/lib/intel64/*.so* %{buildroot}/%{_libdir}/
mv %{buildroot}/usr/lib/intel64/*.a %{buildroot}/%{_libdir}/
rm -rf %{buildroot}/usr/lib/intel64

%files
%license LICENSE
%{_libdir}/libippcp.so.*
%{_libdir}/libcrypto_mb.so.*

%files devel
%{_libdir}/libippcp.so
%{_libdir}/libcrypto_mb.so
%{_prefix}/lib/pkgconfig/*.pc
%{_prefix}/tools/intel64/staticlib/
%{_prefix}/tools/custom_library_tool_python/
%{_includedir}/*.h
%{_includedir}/crypto_mb/*.h
%{_prefix}/lib/cmake/ippcp/

%files static
%{_libdir}/libippcp.a
%{_libdir}/libcrypto_mb.a

%files doc
%doc README.md DEPRECATION_NOTES.md CHANGELOG.md
%doc CONST_TIME_EXECUTION_TESTING.md SECURITY.md
%doc sources/ippcp/crypto_mb/Readme.md

%changelog
* Mon Jul 22 2024 Guanjun <guanjun@linux.alibaba.com> - 1.0.6-4
- Upgrade the dependent OpenSSL library to version 3.x.

* Mon Aug 21 2023 Guanjun <guanjun@linux.alibaba.com> - 1.0.6-3
- Fix qatengine id not found

* Tue Jun 27 2023 xiaojun Huang <xiaojun.huang@intel.com> - 1.0.6-2
- Add other ippcp libs and headers

* Mon Feb 27 2023 happy_orange <songnannan@linux.alibaba.com> - 1.0.6-1
- Update to 1.0.6

* Thu Oct 13 2022 happy_orange <songnannan@linux.alibaba.com> - 1.0.5-1
- Init package from upstream
